﻿using System.Collections;
using System.Collections.Generic;
using System.Linq;
using UnityEngine;

public class Hero
{
	public struct HeroData
	{
		public string name;
		public Sprite sprite;
		public bool female;
	}

	HeroData data;
	EnemyData currentTarget;
	int money;
	int lives;
	List<ItemData> itemsToUse;

	public Hero(HeroData heroData)
	{
		data = heroData;
		lives = 3;
	}
	
	public void SetNewTarget(BestiaryData bestiary)
	{
		var potentialTargets = bestiary.enemies.Where(x => x.enemyLevel == EnemyData.EnemyLevel.Low).ToList();
		int targetIndex = Random.Range(0, potentialTargets.Count);
		var target = potentialTargets[targetIndex];
		currentTarget = target;

		// For now, money is random on a per target basis
		money = Random.Range(10, 100);
	}

	public HeroData GetHeroData()
	{
		return data;
	}

	public EnemyData GetCurrentTarget()
	{
		return currentTarget;
	}

	public int GetCurrentMoney()
	{
		return money;
	}

	public List<ItemData> GetItems()
	{
		return itemsToUse;
	}

	public int GetLives()
	{
		return lives;
	}

	public void SetItems(List<ItemData> items)
	{
		itemsToUse = items;
	}

	public void FightEnemy()
	{
		int itemsMatched = 0;
		for(int i = 0; i < itemsToUse.Count; i++)
		{
			var item = itemsToUse[i];
			for(int j = 0; j < currentTarget.itemsWeakAgainst.Length; j++)
			{
				var weakItem = currentTarget.itemsWeakAgainst[j];
				if (weakItem == null) continue;

				if(item.Name == weakItem.Name)
				{
					itemsMatched++;
				}
			}
		}

		int itemsToMatch = ((int)currentTarget.enemyLevel) + 1;
		
		if(itemsMatched < itemsToMatch)
		{
			lives--;
		}
	}
}
