﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class EnemySaleScreen : MonoBehaviour
{
	public Image enemySprite;
	public Text enemyName;
	public Image[] weaknessImages;

	public void SetEnemyData(EnemyData data)
	{
		gameObject.SetActive(true);
		enemySprite.sprite = data.Image;
		enemySprite.color = data.color;
		enemyName.text = data.Name;

		for(int i = 0; i < weaknessImages.Length; i++)
		{
			if(i < data.itemsWeakAgainst.Length)
			{
				weaknessImages[i].gameObject.SetActive(true);
				weaknessImages[i].sprite = data.itemsWeakAgainst[i].Image;
				weaknessImages[i].color = data.itemsWeakAgainst[i].color;
			}
			else
			{
				weaknessImages[i].gameObject.SetActive(false);
			}
		}
	}

	public void Hide()
	{
		gameObject.SetActive(false);
	}
}
