﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class StockRetakeScreen : BaseScreen
{
	public Button stockTab, bestiaryTab;
	public RectTransform stockScreen, bestiaryScreen;
	public ItemStockScreen[] items;
	public EnemySaleScreen[] enemies; // Fuck making the same class again 

	private bool bestiaryActive;
	private int stockPageIndex;
	private int bestiaryPageIndex;
	private int pageLength = 6;

	private void Start()
	{
		bestiaryActive = false;
		stockPageIndex = 0;
		bestiaryPageIndex = 0;
		UpdatePage();
	}

	public override void ShowScreen()
	{
		base.ShowScreen();
		bestiaryActive = false;
		stockPageIndex = 0;
		bestiaryPageIndex = 0;
		UpdatePage();
	}

	public void ChangeTab(int tab)
	{
		bestiaryActive = tab == 1;
		UpdatePage();
	}

	public void IncrementPage()
	{
		if (!bestiaryActive)
		{
			var itemData = Main.Inst.GetItemsInCatalogue();
			int maxPages = itemData.Length / pageLength + ((itemData.Length % pageLength > 0) ? 1 : 0);
			if (stockPageIndex + 1 == maxPages) return;
			stockPageIndex++;
		}
		else
		{
			var enemyData = Main.Inst.GetEnemiesInBestiary();
			int maxPages = enemyData.Length / pageLength + ((enemyData.Length % pageLength > 0) ? 1 : 0);
			if (bestiaryPageIndex + 1 == maxPages) return;
			bestiaryPageIndex++;
		}
		
		UpdatePage();
	}

	public void DecrementPage()
	{
		if (!bestiaryActive)
		{
			if (stockPageIndex == 0) return;
			stockPageIndex--;
		}
		else
		{
			if (bestiaryPageIndex == 0) return;
			bestiaryPageIndex--;
		}
		UpdatePage();
	}

	private void UpdatePage()
	{
		stockScreen.gameObject.SetActive(!bestiaryActive);
		bestiaryScreen.gameObject.SetActive(bestiaryActive);

		if(!bestiaryActive)
		{
			var itemData = Main.Inst.GetItemsInCatalogue();
			int startIndex = stockPageIndex * pageLength;
			int endIndex = Mathf.Min(itemData.Length, (stockPageIndex + 1) * pageLength);
			int adjustedPageLength = endIndex - startIndex;

			for (int i = 0; i < adjustedPageLength; i++)
			{
				items[i].SetStockedItemData(itemData[startIndex + i]);
			}

			int numToBlank = pageLength - adjustedPageLength;
			for (int i = pageLength - numToBlank; i < pageLength; i++)
			{
				items[i].Hide();
			}
		}
		else
		{
			var enemyData = Main.Inst.GetEnemiesInBestiary();
			int startIndex = bestiaryPageIndex * pageLength;
			int endIndex = Mathf.Min(enemyData.Length, (bestiaryPageIndex + 1) * pageLength);
			int adjustedPageLength = endIndex - startIndex;

			for (int i = 0; i < adjustedPageLength; i++)
			{
				enemies[i].SetEnemyData(enemyData[startIndex + i]);
			}

			int numToBlank = pageLength - adjustedPageLength;
			for (int i = pageLength - numToBlank; i < pageLength; i++)
			{
				enemies[i].Hide();
			}
		}
	}

	public void AddItemToStock(int stockItemIndex)
	{
		var itemData = items[stockItemIndex].GetItemData();
		if (Main.Inst.money - itemData.WholesaleMinValue < 0) return;

		Main.Inst.money -= itemData.WholesaleMinValue;
		Main.Inst.AddItemToStock(itemData);
		UpdatePage();
	}
}
